/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace ExpenseReports {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        /** Additional headers to include in requests. */
        headers?: Record<string, string | core.Supplier<string | undefined> | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string | core.Supplier<string | undefined> | undefined>;
    }
}
export declare class ExpenseReports {
    protected readonly _options: ExpenseReports.Options;
    constructor(_options: ExpenseReports.Options);
    /**
     * Returns a list of `ExpenseReport` objects.
     *
     * @param {Merge.accounting.ExpenseReportsListRequest} request
     * @param {ExpenseReports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenseReports.list()
     */
    list(request?: Merge.accounting.ExpenseReportsListRequest, requestOptions?: ExpenseReports.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedExpenseReportList>;
    private __list;
    /**
     * Creates an `ExpenseReport` object with the given values.
     *
     * @param {Merge.accounting.ExpenseReportEndpointRequest} request
     * @param {ExpenseReports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenseReports.create({
     *         model: {
     *             trackingCategories: ["a1b2c3d4-e5f6-4a5b-9c3d-2e1f0a9b8c7d", "d4c3b2a1-9e8f-7g6h-5i4j-3k2l1m0n9o8p"]
     *         }
     *     })
     */
    create(request: Merge.accounting.ExpenseReportEndpointRequest, requestOptions?: ExpenseReports.RequestOptions): core.HttpResponsePromise<Merge.accounting.ExpenseReportResponse>;
    private __create;
    /**
     * Returns a list of `ExpenseReportLine` objects that point to a `ExpenseReport` with the given id.
     *
     * @param {string} expenseReportId
     * @param {Merge.accounting.ExpenseReportsLinesListRequest} request
     * @param {ExpenseReports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenseReports.linesList("expense_report_id")
     */
    linesList(expenseReportId: string, request?: Merge.accounting.ExpenseReportsLinesListRequest, requestOptions?: ExpenseReports.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedExpenseReportLineList>;
    private __linesList;
    /**
     * Returns an `ExpenseReport` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.ExpenseReportsRetrieveRequest} request
     * @param {ExpenseReports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenseReports.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.ExpenseReportsRetrieveRequest, requestOptions?: ExpenseReports.RequestOptions): core.HttpResponsePromise<Merge.accounting.ExpenseReport>;
    private __retrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.ExpenseReportsLinesRemoteFieldClassesListRequest} request
     * @param {ExpenseReports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenseReports.linesRemoteFieldClassesList()
     */
    linesRemoteFieldClassesList(request?: Merge.accounting.ExpenseReportsLinesRemoteFieldClassesListRequest, requestOptions?: ExpenseReports.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __linesRemoteFieldClassesList;
    /**
     * Returns metadata for `ExpenseReport` POSTs.
     *
     * @param {ExpenseReports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenseReports.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: ExpenseReports.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    /**
     * Returns a list of `RemoteFieldClass` objects.
     *
     * @param {Merge.accounting.ExpenseReportsRemoteFieldClassesListRequest} request
     * @param {ExpenseReports.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.expenseReports.remoteFieldClassesList()
     */
    remoteFieldClassesList(request?: Merge.accounting.ExpenseReportsRemoteFieldClassesListRequest, requestOptions?: ExpenseReports.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedRemoteFieldClassList>;
    private __remoteFieldClassesList;
    protected _getAuthorizationHeader(): Promise<string>;
}
