/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Merge from "../../../../../index";
export declare namespace Items {
    interface Options {
        environment?: core.Supplier<environments.MergeEnvironment | string>;
        /** Specify a custom URL to connect the client to. */
        baseUrl?: core.Supplier<string>;
        apiKey: core.Supplier<core.BearerToken>;
        /** Override the X-Account-Token header */
        accountToken?: core.Supplier<string | undefined>;
        /** Additional headers to include in requests. */
        headers?: Record<string, string | core.Supplier<string | undefined> | undefined>;
        fetcher?: core.FetchFunction;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Override the X-Account-Token header */
        accountToken?: string | undefined;
        /** Additional headers to include in the request. */
        headers?: Record<string, string | core.Supplier<string | undefined> | undefined>;
    }
}
export declare class Items {
    protected readonly _options: Items.Options;
    constructor(_options: Items.Options);
    /**
     * Returns a list of `Item` objects.
     *
     * @param {Merge.accounting.ItemsListRequest} request
     * @param {Items.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.items.list()
     */
    list(request?: Merge.accounting.ItemsListRequest, requestOptions?: Items.RequestOptions): core.HttpResponsePromise<Merge.accounting.PaginatedItemList>;
    private __list;
    /**
     * Creates an `Item` object with the given values.
     *
     * @param {Merge.accounting.ItemEndpointRequest} request
     * @param {Items.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.items.create({
     *         model: {}
     *     })
     */
    create(request: Merge.accounting.ItemEndpointRequest, requestOptions?: Items.RequestOptions): core.HttpResponsePromise<Merge.accounting.ItemResponse>;
    private __create;
    /**
     * Returns an `Item` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.ItemsRetrieveRequest} request
     * @param {Items.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.items.retrieve("id")
     */
    retrieve(id: string, request?: Merge.accounting.ItemsRetrieveRequest, requestOptions?: Items.RequestOptions): core.HttpResponsePromise<Merge.accounting.Item>;
    private __retrieve;
    /**
     * Updates an `Item` object with the given `id`.
     *
     * @param {string} id
     * @param {Merge.accounting.PatchedItemEndpointRequest} request
     * @param {Items.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.items.partialUpdate("id", {
     *         model: {}
     *     })
     */
    partialUpdate(id: string, request: Merge.accounting.PatchedItemEndpointRequest, requestOptions?: Items.RequestOptions): core.HttpResponsePromise<Merge.accounting.ItemResponse>;
    private __partialUpdate;
    /**
     * Returns metadata for `Item` PATCHs.
     *
     * @param {string} id
     * @param {Items.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.items.metaPatchRetrieve("id")
     */
    metaPatchRetrieve(id: string, requestOptions?: Items.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPatchRetrieve;
    /**
     * Returns metadata for `Item` POSTs.
     *
     * @param {Items.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @example
     *     await client.accounting.items.metaPostRetrieve()
     */
    metaPostRetrieve(requestOptions?: Items.RequestOptions): core.HttpResponsePromise<Merge.accounting.MetaResponse>;
    private __metaPostRetrieve;
    protected _getAuthorizationHeader(): Promise<string>;
}
