/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Merge from "../../../index";
/**
 * # The Item Object
 * ### Description
 * The `Item` object refers to the goods involved in a transaction.
 *
 * ### Usage Example
 * Fetch from the `LIST Items` endpoint and view a company's items.
 */
export interface ItemRequestRequest {
    /** The item's name. */
    name?: string;
    /**
     * The item's status.
     *
     * * `ACTIVE` - ACTIVE
     * * `ARCHIVED` - ARCHIVED
     */
    status?: Merge.accounting.ItemRequestRequestStatus;
    /**
     * The item's type.
     *
     * * `INVENTORY` - INVENTORY
     * * `NON_INVENTORY` - NON_INVENTORY
     * * `SERVICE` - SERVICE
     * * `UNKNOWN` - UNKNOWN
     */
    type?: Merge.accounting.ItemRequestRequestType;
    /** The item's unit price. */
    unitPrice?: number;
    /** The price at which the item is purchased from a vendor. */
    purchasePrice?: number;
    /** References the default account used to record a purchase of the item. */
    purchaseAccount?: Merge.accounting.ItemRequestRequestPurchaseAccount;
    /** References the default account used to record a sale. */
    salesAccount?: Merge.accounting.ItemRequestRequestSalesAccount;
    /** The company the item belongs to. */
    company?: Merge.accounting.ItemRequestRequestCompany;
    /** The default purchase tax rate for this item. */
    purchaseTaxRate?: Merge.accounting.ItemRequestRequestPurchaseTaxRate;
    /** The default sales tax rate for this item. */
    salesTaxRate?: Merge.accounting.ItemRequestRequestSalesTaxRate;
    integrationParams?: Record<string, unknown>;
    linkedAccountParams?: Record<string, unknown>;
}
